# Mini-XML 4.0 Programming Manual

Michael R Sweet

Copyright © 2003-2025, All Rights Reserved.

## Contents

- Introduction
  - History
  - Resources
  - Legal Stuff
- Using Mini-XML
  - API Basics
  - Loading an XML File
  - Finding Nodes
  - Getting the Value(s) from Nodes
  - Saving an XML File
  - Freeing Memory
- Creating New XML Documents
  - Element Nodes
  - CDATA Nodes
  - Comment Nodes
  - Processing Instruction Nodes
  - Integer Nodes
  - Opaque String Nodes
  - Real Number Nodes
  - Text Nodes
- Iterating and Indexing the Tree
  - Iterating Nodes
  - Indexing
- Advanced Usage
  - Custom Data Types
  - SAX (Stream) Loading of Documents
  - User Data
  - Memory Management
- Migrating from Mini-XML v3.x
- Functions
  - mxmlAdd
  - mxmlDelete
  - mxmlElementClearAttr
  - mxmlElementGetAttr
  - mxmlElementGetAttrByIndex
  - mxmlElementGetAttrCount
  - mxmlElementSetAttr
  - mxmlElementSetAttrf
  - mxmlFindElement
  - mxmlFindPath
  - mxmlGetCDATA
  - mxmlGetComment
  - mxmlGetCustom
  - mxmlGetDeclaration
  - mxmlGetDirective
  - mxmlGetElement
  - mxmlGetFirstChild
  - mxmlGetInteger
  - mxmlGetLastChild
  - mxmlGetNextSibling
  - mxmlGetOpaque
  - mxmlGetParent
  - mxmlGetPrevSibling
  - mxmlGetReal
  - mxmlGetRefCount
  - mxmlGetText
  - mxmlGetType
  - mxmlGetUserData
  - mxmlIndexDelete
  - mxmlIndexEnum
  - mxmlIndexFind
  - mxmlIndexGetCount
  - mxmlIndexNew
  - mxmlIndexReset
  - mxmlLoadFd
  - mxmlLoadFile
  - mxmlLoadFilename
  - mxmlLoadIO
  - mxmlLoadString
  - mxmlNewCDATA
  - mxmlNewCDATAf
  - mxmlNewComment
  - mxmlNewCommentf
  - mxmlNewCustom
  - mxmlNewDeclaration
  - mxmlNewDeclarationf
  - mxmlNewDirective
  - mxmlNewDirectivef
  - mxmlNewElement
  - mxmlNewInteger
  - mxmlNewOpaque
  - mxmlNewOpaquef
  - mxmlNewReal
  - mxmlNewText
  - mxmlNewTextf
  - mxmlNewXML
  - mxmlOptionsDelete
  - mxmlOptionsNew
  - mxmlOptionsSetCustomCallbacks
  - mxmlOptionsSetEntityCallback
  - mxmlOptionsSetErrorCallback
  - mxmlOptionsSetSAXCallback
  - mxmlOptionsSetTypeCallback
  - mxmlOptionsSetTypeValue
  - mxmlOptionsSetWhitespaceCallback
  - mxmlOptionsSetWrapMargin
  - mxmlRelease
  - mxmlRemove
  - mxmlRetain
  - mxmlSaveAllocString
  - mxmlSaveFd
  - mxmlSaveFile
  - mxmlSaveFilename
  - mxmlSaveIO
  - mxmlSaveString
  - mxmlSetCDATA
  - mxmlSetCDATAf
  - mxmlSetComment
  - mxmlSetCommentf
  - mxmlSetCustom
  - mxmlSetDeclaration
  - mxmlSetDeclarationf
  - mxmlSetDirective
  - mxmlSetDirectivef
  - mxmlSetElement
  - mxmlSetInteger
  - mxmlSetOpaque
  - mxmlSetOpaquef
  - mxmlSetReal
  - mxmlSetText
  - mxmlSetTextf
  - mxmlSetUserData
  - mxmlWalkNext
  - mxmlWalkPrev
- Data Types
  - mxml_add_t
  - mxml_custfree_cb_t
  - mxml_custload_cb_t
  - mxml_custsave_cb_t
  - mxml_descend_t
  - mxml_entity_cb_t
  - mxml_error_cb_t
  - mxml_index_t
  - mxml_io_cb_t
  - mxml_node_t
  - mxml_options_t
  - mxml_sax_cb_t
  - mxml_sax_event_t
  - mxml_strcopy_cb_t
  - mxml_strfree_cb_t
  - mxml_type_cb_t
  - mxml_type_t
  - mxml_ws_cb_t
  - mxml_ws_t
- Enumerations
  - mxml_add_e
  - mxml_descend_e
  - mxml_sax_event_e
  - mxml_type_e
  - mxml_ws_e

## Introduction

Mini-XML is a small XML parsing library that you can use to read XML data files or strings in your application without requiring large non-standard libraries. Mini-XML provides the following functionality:

- Reading of UTF-8 and UTF-16 and writing of UTF-8 encoded XML files and strings.

- Data is stored in a linked-list tree structure, preserving the XML data hierarchy.

- SAX (streamed) reading of XML files and strings to minimize memory usage.

- Supports arbitrary element names, attributes, and attribute values with no preset limits, just available memory.

- Supports integer, real, opaque ("CDATA"), text, and custom data types in "leaf" nodes.

- Functions for creating and managing trees of data.

- "Find" and "walk" functions for easily locating and navigating trees of data.

- Support for custom string memory management functions to implement string pools and other schemes for reducing memory usage.

Mini-XML doesn't do validation or other types of processing on the data based upon schema files or other sources of definition information.

### History

Mini-XML was initially developed for the Gutenprint project to replace the rather large and unwieldy `libxml2` library with something substantially smaller and easier-to-use. It all began one morning in June of 2003 when Robert posted the following sentence to the developer's list:

> It's bad enough that we require libxml2, but rolling our own XML parser is a bit more than we can handle.

I then replied with:

> Given the limited scope of what you use in XML, it should be trivial to code a mini-XML API in a few hundred lines of code.

I took my own challenge and coded furiously for two days to produce the initial public release of Mini-XML, total lines of code: 696. Robert promptly integrated Mini-XML into Gutenprint and removed libxml2.

Thanks to lots of feedback and support from various developers, Mini-XML has evolved since then to provide a more complete XML implementation and now stands at a whopping 3,491 lines of code, compared to 175,808 lines of code for libxml2 version 2.11.7.

### Resources

The Mini-XML home page can be found at https://www.msweet.org/mxml. From there you can download the current version of Mini-XML, access the issue tracker, and find other resources.

Mini-XML v4 has a slightly different API than prior releases. See the Migrating from Mini-XML v3.x chapter for details.

### Legal Stuff

The Mini-XML library is copyright © 2003-2024 by Michael R Sweet and is provided under the Apache License Version 2.0 with an (optional) exception to allow linking against GPL2/LGPL2-only software. See the files "LICENSE" and "NOTICE" for more information.

## Using Mini-XML

Mini-XML provides a single header file which you include:

    #include <mxml.h>

The Mini-XML library is included with your program using the `-lmxml4` option:

    gcc -o myprogram myprogram.c -lmxml4

If you have the `pkg-config` software installed, you can use it to determine the proper compiler and linker options for your installation:

    gcc `pkg-config --cflags mxml4` -o myprogram myprogram.c `pkg-config --libs mxml4`

> Note: The library name "mxml4" is a configure-time option. If you use the

> `--disable-libmxml4-prefix` configure option the library is named "mxml".

### API Basics

Every piece of information in an XML file is stored in memory in "nodes". Nodes are represented by `mxml_node_t` pointers. Each node has an associated type, value(s), a parent node, sibling nodes (previous and next), potentially first and last child nodes, and an optional user data pointer.

For example, if you have an XML file like the following:

    <?xml version="1.0" encoding="utf-8"?>
    <data>
        <node>val1</node>
        <node>val2</node>
        <node>val3</node>
        <group>
            <node>val4</node>
            <node>val5</node>
            <node>val6</node>
        </group>
        <node>val7</node>
        <node>val8</node>
    </data>

the node tree for the file would look like the following in memory:

    <?xml version="1.0" encoding="utf-8"?>
      |
    <data>
      |
    <node> - <node> - <node> - <group> - <node> - <node>
      |        |        |         |        |        |
     val1     val2     val3       |       val7     val8
                                  |
                                <node> - <node> - <node>
                                  |        |        |
                                 val4     val5     val6

where "-" is a pointer to the sibling node and "|" is a pointer to the first child or parent node.

The mxmlGetType function gets the type of a node which is represented as a `mxml_type_t` enumeration value:

- `MXML_TYPE_CDATA`: CDATA such as `<![CDATA[...]]>`,

- `MXML_TYPE_COMMENT`: A comment such as `<!-- my comment -->`,

- `MXML_TYPE_CUSTOM`: A custom value defined by your application,

- `MXML_TYPE_DECLARATION`: A declaration such as `<!DOCTYPE html>`,

- `MXML_TYPE_DIRECTIVE`: A processing instruction such as `<?xml version="1.0" encoding="utf-8"?>`,

- `MXML_TYPE_ELEMENT`: An XML element with optional attributes such as `<element name="value">`,

- `MXML_TYPE_INTEGER`: A whitespace-delimited integer value such as `42`,

- `MXML_TYPE_OPAQUE`: An opaque string value that preserves all whitespace such as `All work and no play makes Johnny a dull boy.`,

- `MXML_TYPE_REAL`: A whitespace-delimited floating point value such as `123.4`, or

- `MXML_TYPE_TEXT`: A whitespace-delimited text (fragment) value such as `Word`.

The parent, sibling, and child nodes are accessed using the mxmlGetParent, mxmlGetNextSibling, mxmlGetPreviousSibling, mxmlGetFirstChild, and mxmlGetLastChild functions.

The value(s) of a node are accessed using the mxmlGetCDATA, mxmlGetComment, mxmlGetDeclaration, mxmlGetDirective, mxmlGetElement, mxmlElementGetAttr, mxmlGetInteger, mxmlGetOpaque, mxmlGetReal, and mxmlGetText functions.

### Loading an XML File

You load an XML file using the mxmlLoadFilename function:

    mxml_node_t *
    mxmlLoadFilename(mxml_node_t *top, mxml_options_t *options,
                     const char *filename);

Mini-XML also provides functions to load from a `FILE` pointer, a file descriptor, a string, or using a callback:

    mxml_node_t *
    mxmlLoadFd(mxml_node_t *top, mxml_options_t *options,
               int fd);

    mxml_node_t *
    mxmlLoadFile(mxml_node_t *top, mxml_options_t *options,
                 FILE *fp);

    mxml_node_t *
    mxmlLoadIO(mxml_node_t *top, mxml_options_t *options,
               mxml_io_cb_t io_cb, void *io_cbdata);

    mxml_node_t *
    mxmlLoadString(mxml_node_t *top, mxml_options_t *options,
                   const char *s);

Each accepts a pointer to the top-most ("root") node (usually `NULL`) you want to add the XML data to, any load options, and the content to be loaded. For example, the following code will load an XML file called "example.xml" using the default load options:

    mxml_node_t *xml;

    xml = mxmlLoadFilename(/*top*/NULL, /*options*/NULL,
                           "example.xml");

#### Load Options

Load options are specified using a `mxml_options_t` pointer, which you create using the mxmlOptionsNew function:

    mxml_options_t *options = mxmlOptionsNew();

The default load options will treat any values in your XML as whitespace- delimited text (`MXML_TYPE_TEXT`). You can specify a different type of values using the mxmlOptionsSetTypeValue function. For example, the following will specify that values are opaque text strings, including whitespace (`MXML_TYPE_OPAQUE`):

    mxmlOptionsSetTypeValue(options, MXML_TYPE_OPAQUE);

For more complex XML documents, you can specify a callback that returns the type of value for a given element node using the mxmlOptionsSetTypeCallback function. For example, to specify a callback function called `my_type_cb` that has no callback data:

    mxmlOptionsSetTypeCallback(options, my_type_cb, /*cbdata*/NULL);

The `my_type_cb` function accepts the callback data pointer (`NULL` in this case) and the `mxml_node_t` pointer for the current element and returns a `mxml_type_t` enumeration value specifying the value type for child nodes. For example, the following function looks at the "type" attribute and the element name to determine the value types of the node's children:

    mxml_type_t
    my_load_cb(void *cbdata, mxml_node_t *node)
    {
      const char *type;

     /*
      * You can lookup attributes and/or use the element name,
      * hierarchy, etc...
      */

      type = mxmlElementGetAttr(node, "type");
      if (type == NULL)
        type = mxmlGetElement(node);
      if (type == NULL)
        type = "text";

      if (!strcmp(type, "integer"))
        return (MXML_TYPE_INTEGER);
      else if (!strcmp(type, "opaque"))
        return (MXML_TYPE_OPAQUE);
      else if (!strcmp(type, "real"))
        return (MXML_TYPE_REAL);
      else
        return (MXML_TYPE_TEXT);
    }

### Finding Nodes

The mxmlFindPath function finds the (first) value node under a specific element using a path. The path string can contain the "*" wildcard to match a single element node in the hierarchy. For example, the following code will find the first "node" element under the "group" element, first using an explicit path and then using a wildcard:

    mxml_node_t *directnode = mxmlFindPath(xml, "data/group/node");

    mxml_node_t *wildnode = mxmlFindPath(xml, "data/*/node");

The mxmlFindElement function can be used to find a named element, optionally matching an attribute and value:

    mxml_node_t *
    mxmlFindElement(mxml_node_t *node, mxml_node_t *top,
                    const char *element, const char *attr,
                    const char *value, int descend);

The `element`, `attr`, and `value` arguments can be passed as `NULL` to act as wildcards, e.g.:

    mxml_node_t *node;

    /* Find the first "a" element */
    node = mxmlFindElement(tree, tree, "a", NULL, NULL,
                           MXML_DESCEND_ALL);

    /* Find the first "a" element with "href" attribute */
    node = mxmlFindElement(tree, tree, "a", "href", NULL,
                           MXML_DESCEND_ALL);

    /* Find the first "a" element with "href" to a URL */
    node = mxmlFindElement(tree, tree, "a", "href",
                           "http://msweet.org/",
                           MXML_DESCEND_ALL);

    /* Find the first element with a "src" attribute*/
    node = mxmlFindElement(tree, tree, NULL, "src", NULL,
                           MXML_DESCEND_ALL);

    /* Find the first element with a "src" = "foo.jpg" */
    node = mxmlFindElement(tree, tree, NULL, "src", "foo.jpg",
                           MXML_DESCEND_ALL);

You can also iterate with the same function:

    mxml_node_t *node;

    for (node = mxmlFindElement(tree, tree, "element", NULL,
                                NULL, MXML_DESCEND_ALL);
         node != NULL;
         node = mxmlFindElement(node, tree, "element", NULL,
                                NULL, MXML_DESCEND_ALL))
    {
      ... do something ...
    }

The `descend` argument (`MXML_DESCEND_ALL` in the previous examples) can be one of three constants:

- `MXML_DESCEND_NONE`: ignore child nodes in the element hierarchy, instead using siblings (same level) or parent nodes (above) until the top (root) node is reached.

- `MXML_DESCEND_FIRST`: start the search with the first child of the node, and then search siblings. You'll normally use this when iterating through direct children of a parent node, e.g. all of the `<node>` and `<group>` elements under the `<?xml ...?>` parent node in the previous example.

- `MXML_DESCEND_ALL`: search child nodes first, then sibling nodes, and then parent nodes.

### Getting the Value(s) from Nodes

Once you have the node you can use one of the mxmlGetXxx functions to retrieve its value(s).

Element (`MXML_TYPE_ELEMENT`) nodes have an associated name and zero or more named attributes with (string) values. The mxmlGetElement function retrieves the element name while the mxmlElementGetAttr function retrieves the value string for a named attribute. For example, the following code looks for HTML heading elements and, when found, displays the "id" attribute for the heading:

    const char *elemname = mxmlGetElement(node);
    const char *id_value = mxmlElementGetAttr(node, "id");

    if ((*elemname == 'h' || *elemname == 'H') &&
        elemname[1] >= '1' && elemname[1] <= '6' &&
        id_value != NULL)
      printf("%s: %s\n", elemname, id_value);

The mxmlElementGetAttrByIndex and mxmlElementGetAttrCount functions allow you to iterate all attributes of an element. For example, the following code prints the element name and each of its attributes:

    const char *elemname = mxmlGetElement(node);
    printf("%s:\n", elemname);

    size_t i, count;
    for (i = 0, count = mxmlElementGetAttrCount(node); i < count; i ++)
    {
      const char *attrname, *attrvalue;

      attrvalue = mxmlElementGetAttrByIndex(node, i, &attrname);

      printf("    %s=\"%s\"\n", attrname, attrvalue);
    }

CDATA (`MXML_TYPE_CDATA`) nodes have an associated string value consisting of the text between the `<![CDATA[` and `]]>` delimiters. The mxmlGetCDATA function retrieves the CDATA string pointer for a node. For example, the following code gets the CDATA string value:

    const char *cdatavalue = mxmlGetCDATA(node);

Comment (`MXML_TYPE_COMMENT`) nodes have an associated string value consisting of the text between the `<!--` and `-->` delimiters. The mxmlGetComment function retrieves the comment string pointer for a node. For example, the following code gets the comment string value:

    const char *commentvalue = mxmlGetComment(node);

Processing instruction (`MXML_TYPE_DIRECTIVE`) nodes have an associated string value consisting of the text between the `<?` and `?>` delimiters. The mxmlGetDirective function retrieves the processing instruction string for a node. For example, the following code gets the processing instruction string value:

    const char *instrvalue = mxmlGetDirective(node);

Integer (`MXML_TYPE_INTEGER`) nodes have an associated `long` value. The mxmlGetInteger function retrieves the integer value for a node. For example, the following code gets the integer value:

    long intvalue = mxmlGetInteger(node);

Opaque string (`MXML_TYPE_OPAQUE`) nodes have an associated string value consisting of the text between elements. The mxmlGetOpaque function retrieves the opaque string pointer for a node. For example, the following code gets the opaque string value:

    const char *opaquevalue = mxmlGetOpaque(node);

Real number (`MXML_TYPE_REAL`) nodes have an associated `double` value. The mxmlGetReal function retrieves the real number for a node. For example, the following code gets the real value:

    double realvalue = mxmlGetReal(node);

Whitespace-delimited text string (`MXML_TYPE_TEXT`) nodes have an associated whitespace indicator and string value extracted from the text between elements. The mxmlGetText function retrieves the text string pointer and whitespace boolean value for a node. For example, the following code gets the text and whitespace indicator:

    const char *textvalue;
    bool whitespace;

    textvalue = mxmlGetText(node, &whitespace);

### Saving an XML File

You save an XML file using the mxmlSaveFilename function:

    bool
    mxmlSaveFilename(mxml_node_t *node, mxml_options_t *options,
                     const char *filename);

Mini-XML also provides functions to save to a `FILE` pointer, a file descriptor, a string, or using a callback:

    char *
    mxmlSaveAllocString(mxml_node_t *node, mxml_options_t *options);

    bool
    mxmlSaveFd(mxml_node_t *node, mxml_options_t *options,
               int fd);

    bool
    mxmlSaveFile(mxml_node_t *node, mxml_options_t *options,
                 FILE *fp);

    bool
    mxmlSaveIO(mxml_node_t *node, mxml_options_t *options,
               mxml_io_cb_t *io_cb, void *io_cbdata);

    size_t
    mxmlSaveString(mxml_node_t *node, mxml_options_t *options,
                   char *buffer, size_t bufsize);

Each accepts a pointer to the top-most ("root") node, any save options, and (as needed) the destination. For example, the following code saves an XML file to the file "example.xml" with the default options:

    mxmlSaveFile(xml, /*options*/NULL, "example.xml");

#### Save Options

Save options are specified using a `mxml_options_t` pointer, which you create using the mxmlOptionsNew function:

    mxml_options_t *options = mxmlOptionsNew();

The default save options will wrap output lines at column 72 but not add any additional whitespace otherwise. You can change the wrap column using the mxmlOptionsSetWrapMargin function. For example, the following will set the wrap column to 0 which disables wrapping:

    mxmlOptionsSetWrapMargin(options, 0);

To add additional whitespace to the output, set a whitespace callback using the mxmlOptionsSetWhitespaceCallback function. A whitespace callback accepts a callback data pointer, the current node, and a whitespace position value of `MXML_WS_BEFORE_OPEN`, `MXML_WS_AFTER_OPEN`, `MXML_WS_BEFORE_CLOSE`, or `MXML_WS_AFTER_CLOSE`. The callback should return `NULL` if no whitespace is to be inserted or a string of spaces, tabs, carriage returns, and newlines to insert otherwise.

The following whitespace callback can be used to add whitespace to XHTML output to make it more readable in a standard text editor:

    const char *
    whitespace_cb(void *cbdata, mxml_node_t *node, mxml_ws_t where)
    {
      const char *element;

     /*
      * We can conditionally break to a new line before or after
      * any element.  These are just common HTML elements...
      */

      element = mxmlGetElement(node);

      if (!strcmp(element, "html") ||
          !strcmp(element, "head") ||
          !strcmp(element, "body") ||
          !strcmp(element, "pre") ||
          !strcmp(element, "p") ||
          !strcmp(element, "h1") ||
          !strcmp(element, "h2") ||
          !strcmp(element, "h3") ||
          !strcmp(element, "h4") ||
          !strcmp(element, "h5") ||
          !strcmp(element, "h6"))
      {
       /*
        * Newlines before open and after close...
        */

        if (where == MXML_WS_BEFORE_OPEN ||
            where == MXML_WS_AFTER_CLOSE)
          return ("\n");
      }
      else if (!strcmp(element, "dl") ||
               !strcmp(element, "ol") ||
               !strcmp(element, "ul"))
      {
       /*
        * Put a newline before and after list elements...
        */

        return ("\n");
      }
      else if (!strcmp(element, "dd") ||
               !strcmp(element, "dt") ||
               !strcmp(element, "li"))
      {
       /*
        * Put a tab before <li>'s, <dd>'s, and <dt>'s, and a
        * newline after them...
        */

        if (where == MXML_WS_BEFORE_OPEN)
          return ("\t");
        else if (where == MXML_WS_AFTER_CLOSE)
          return ("\n");
      }

     /*
      * Otherwise return NULL for no added whitespace...
      */

      return (NULL);
    }

The following code will set the whitespace callback for the save options:

    mxmlOptionsSetWhitespaceCallback(options, whitespace_cb, /*cbdata*/NULL);

### Freeing Memory

Once you are done with the XML data, use the mxmlDelete function to free the memory that is used for a particular node and its children. For example, the following code frees the XML data loaded by the previous examples:

    mxmlDelete(xml);

## Creating New XML Documents

You can create new and update existing XML documents in memory using the various mxmlNewXxx functions. The following code will create the XML document described in the Using Mini-XML chapter:

    mxml_node_t *xml;    /* <?xml version="1.0" charset="utf-8"?> */
    mxml_node_t *data;   /* <data> */
    mxml_node_t *node;   /* <node> */
    mxml_node_t *group;  /* <group> */

    xml = mxmlNewXML("1.0");

    data = mxmlNewElement(xml, "data");

      node = mxmlNewElement(data, "node");
      mxmlNewText(node, false, "val1");
      node = mxmlNewElement(data, "node");
      mxmlNewText(node, false, "val2");
      node = mxmlNewElement(data, "node");
      mxmlNewText(node, false, "val3");

      group = mxmlNewElement(data, "group");

        node = mxmlNewElement(group, "node");
        mxmlNewText(node, false, "val4");
        node = mxmlNewElement(group, "node");
        mxmlNewText(node, false, "val5");
        node = mxmlNewElement(group, "node");
        mxmlNewText(node, false, "val6");

      node = mxmlNewElement(data, "node");
      mxmlNewText(node, false, "val7");
      node = mxmlNewElement(data, "node");
      mxmlNewText(node, false, "val8");

We start by creating the processing instruction node common to all XML files using the mxmlNewXML function:

    xml = mxmlNewXML("1.0");

We then create the `<data>` node used for this document using the mxmlNewElement function. The first argument specifies the parent node (`xml`) while the second specifies the element name (`data`):

    data = mxmlNewElement(xml, "data");

Each `<node>...</node>` in the file is created using the mxmlNewElement and mxmlNewText functions. The first argument of mxmlNewText specifies the parent node (`node`). The second argument specifies whether whitespace appears before the text - `false` in this case. The last argument specifies the actual text to add:

    node = mxmlNewElement(data, "node");
    mxmlNewText(node, false, "val1");

The resulting in-memory XML document can then be saved or processed just like one loaded from disk or a string.

### Element Nodes

Element (`MXML_TYPE_ELEMENT`) nodes are created using the mxmlNewElement function. Element attributes are set using the mxmlElementSetAttr and mxmlElementSetAttrf functions and cleared using the mxmlElementClearAttr function:

    mxml_node_t *
    mxmlNewElement(mxml_node_t *parent, const char *name);

    void
    mxmlElementClearAttr(mxml_node_t *node, const char *name);

    void
    mxmlElementSetAttr(mxml_node_t *node, const char *name,
                       const char *value);

    void
    mxmlElementSetAttrf(mxml_node_t *node, const char *name,
                        const char *format, ...);

### CDATA Nodes

CDATA (`MXML_TYPE_CDATA`) nodes are created using the mxmlNewCDATA and mxmlNewCDATAf functions and set using the mxmlSetCDATA and mxmlSetCDATAf functions:

    mxml_node_t *
    mxmlNewCDATA(mxml_node_t *parent, const char *string);

    mxml_node_t *
    mxmlNewCDATAf(mxml_node_t *parent, const char *format, ...);

    void
    mxmlSetCDATA(mxml_node_t *node, const char *string);

    void
    mxmlSetCDATAf(mxml_node_t *node, const char *format, ...);

### Comment Nodes

Comment (`MXML_TYPE_COMMENT`) nodes are created using the mxmlNewComment and mxmlNewCommentf functions and set using the mxmlSetComment and mxmlSetCommentf functions:

    mxml_node_t *
    mxmlNewComment(mxml_node_t *parent, const char *string);

    mxml_node_t *
    mxmlNewCommentf(mxml_node_t *parent, const char *format, ...);

    void
    mxmlSetComment(mxml_node_t *node, const char *string);

    void
    mxmlSetCommentf(mxml_node_t *node, const char *format, ...);

### Processing Instruction Nodes

Processing instruction (`MXML_TYPE_DIRECTIVE`) nodes are created using the mxmlNewDirective and mxmlNewDirectivef functions and set using the mxmlSetDirective and mxmlSetDirectivef functions:

    mxml_node_t *node = mxmlNewDirective("xml-stylesheet type=\"text/css\" href=\"style.css\"");

    mxml_node_t *node = mxmlNewDirectivef("xml version=\"%s\"", version);

The mxmlNewXML function can be used to create the top-level "xml" processing instruction with an associated version number:

    mxml_node_t *
    mxmlNewXML(const char *version);

### Integer Nodes

Integer (`MXML_TYPE_INTEGER`) nodes are created using the mxmlNewInteger function and set using the mxmlSetInteger function:

    mxml_node_t *
    mxmlNewInteger(mxml_node_t *parent, long integer);

    void
    mxmlSetInteger(mxml_node_t *node, long integer);

### Opaque String Nodes

Opaque string (`MXML_TYPE_OPAQUE`) nodes are created using the mxmlNewOpaque and mxmlNewOpaquef functions and set using the mxmlSetOpaque and mxmlSetOpaquef functions:

    mxml_node_t *
    mxmlNewOpaque(mxml_node_t *parent, const char *opaque);

    mxml_node_t *
    mxmlNewOpaquef(mxml_node_t *parent, const char *format, ...);

    void
    mxmlSetOpaque(mxml_node_t *node, const char *opaque);

    void
    mxmlSetOpaquef(mxml_node_t *node, const char *format, ...);

### Real Number Nodes

Real number (`MXML_TYPE_REAL`) nodes are created using the mxmlNewReal function and set using the mxmlSetReal function:

    mxml_node_t *
    mxmlNewReal(mxml_node_t *parent, double real);

    void
    mxmlSetReal(mxml_node_t *node, double real);

### Text Nodes

Whitespace-delimited text string (`MXML_TYPE_TEXT`) nodes are created using the mxmlNewText and mxmlNewTextf functions and set using the mxmlSetText and mxmlSetTextf functions. Each text node consists of a text string and (leading) whitespace boolean value.

    mxml_node_t *
    mxmlNewText(mxml_node_t *parent, bool whitespace,
                const char *string);

    mxml_node_t *
    mxmlNewTextf(mxml_node_t *parent, bool whitespace,
                 const char *format, ...);

    void
    mxmlSetText(mxml_node_t *node, bool whitespace,
                const char *string);

    void
    mxmlSetTextf(mxml_node_t *node, bool whitespace,
                 const char *format, ...);

## Iterating and Indexing the Tree

### Iterating Nodes

While the mxmlFindNode and mxmlFindPath functions will find a particular element node, sometimes you need to iterate over all nodes. The mxmlWalkNext and mxmlWalkPrev functions can be used to iterate through the XML node tree:

    mxml_node_t *
    mxmlWalkNext(mxml_node_t *node, mxml_node_t *top,
                 int descend);

    mxml_node_t *
    mxmlWalkPrev(mxml_node_t *node, mxml_node_t *top,
                 int descend);

Depending on the value of the `descend` argument, these functions will automatically traverse child, sibling, and parent nodes until the `top` node is reached. For example, the following code will iterate over all of the nodes in the sample XML document in the Using Mini-XML chapter:

    mxml_node_t *node;

    for (node = xml;
         node != NULL;
         node = mxmlWalkNext(node, xml, MXML_DESCEND_ALL))
    {
      ... do something ...
    }

The nodes will be returned in the following order:

    <?xml version="1.0" encoding="utf-8"?>
    <data>
    <node>
    val1
    <node>
    val2
    <node>
    val3
    <group>
    <node>
    val4
    <node>
    val5
    <node>
    val6
    <node>
    val7
    <node>
    val8

### Indexing

The mxmlIndexNew function allows you to create an index of nodes for faster searching and enumeration:

    mxml_index_t *
    mxmlIndexNew(mxml_node_t *node, const char *element,
                 const char *attr);

The `element` and `attr` arguments control which elements are included in the index. If `element` is not `NULL` then only elements with the specified name are added to the index. Similarly, if `attr` is not `NULL` then only elements containing the specified attribute are added to the index. The nodes are sorted in the index.

For example, the following code creates an index of all "id" values in an XML document:

    mxml_index_t *ind = mxmlIndexNew(xml, NULL, "id");

Once the index is created, the mxmlIndexFind function can be used to find a matching node:

    mxml_node_t *
    mxmlIndexFind(mxml_index_t *ind, const char *element,
                  const char *value);

For example, the following code will find the element whose "id" string is "42":

    mxml_node_t *node = mxmlIndexFind(ind, NULL, "42");

Alternately, the mxmlIndexReset and mxmlIndexEnum functions can be used to enumerate the nodes in the index:

    mxml_node_t *
    mxmlIndexReset(mxml_index_t *ind);

    mxml_node_t *
    mxmlIndexEnum(mxml_index_t *ind);

Typically these functions will be used in a `for` loop:

    mxml_node_t *node;

    for (node = mxmlIndexReset(ind);
         node != NULL;
         node = mxmlIndexEnum(ind))
    {
      ... do something ...
    }

The mxmlIndexCount function returns the number of nodes in the index:

    size_t
    mxmlIndexGetCount(mxml_index_t *ind);

Finally, the mxmlIndexDelete function frees all memory associated with the index:

    void
    mxmlIndexDelete(mxml_index_t *ind);

## Advanced Usage

### Custom Data Types

Mini-XML supports custom data types via load and save callback options. Only a single set of callbacks can be active at any time for a `mxml_options_t` pointer, however your callbacks can store additional information in order to support multiple custom data types as needed. The `MXML_TYPE_CUSTOM` node type identifies custom data nodes.

The mxmlGetCustom function retrieves the custom value pointer for a node.

    const void *
    mxmlGetCustom(mxml_node_t *node);

Custom (`MXML_TYPE_CUSTOM`) nodes are created using the mxmlNewCustom function or using the custom load callback specified using the mxmlOptionsSetCustomCallbacks function:

    typedef void (*mxml_custfree_cb_t)(void *cbdata, void *data);
    typedef bool (*mxml_custload_cb_t)(void *cbdata, mxml_node_t *, const char *);
    typedef char *(*mxml_custsave_cb_t)(void *cbdata, mxml_node_t *);

    mxml_node_t *
    mxmlNewCustom(mxml_node_t *parent, void *data,
                  mxml_custfree_cb_t free_cb, void *free_cbdata);

    int
    mxmlSetCustom(mxml_node_t *node, void *data,
                  mxml_custfree_cb_t free_cb, void *free_cbdata);

    void
    mxmlOptionsSetCustomCallbacks(mxml_option_t *options,
                                  mxml_custload_cb_t load_cb,
                                  mxml_custsave_cb_t save_cb,
                                  void *cbdata);

The load callback receives the callback data pointer, a pointer to the current data node, and a string of opaque character data from the XML source with character entities converted to the corresponding UTF-8 characters. For example, if we wanted to support a custom date/time type whose value is encoded as "yyyy-mm-ddThh:mm:ssZ" (ISO 8601 format), the load callback would look like the following:

    typedef struct iso_date_time_s
    {
      unsigned year,    /* Year */
               month,   /* Month */
               day,     /* Day */
               hour,    /* Hour */
               minute,  /* Minute */
               second;  /* Second */
      time_t   unix;    /* UNIX time */
    } iso_date_time_t;

    bool
    custom_load_cb(void *cbdata, mxml_node_t *node, const char *data)
    {
      iso_date_time_t *dt;
      struct tm tmdata;

     /*
      * Allocate data structure...
      */

      dt = calloc(1, sizeof(iso_date_time_t));

     /*
      * Try reading 6 unsigned integers from the data string...
      */

      if (sscanf(data, "%u-%u-%uT%u:%u:%uZ", &(dt->year),
                 &(dt->month), &(dt->day), &(dt->hour),
                 &(dt->minute), &(dt->second)) != 6)
      {
       /*
        * Unable to read numbers, free the data structure and
        * return an error...
        */

        free(dt);

        return (false);
      }

     /*
      * Range check values...
      */

      if (dt->month < 1 || dt->month > 12 ||
          dt->day < 1 || dt->day > 31 ||
          dt->hour < 0 || dt->hour > 23 ||
          dt->minute < 0 || dt->minute > 59 ||
          dt->second < 0 || dt->second > 60)
      {
       /*
        * Date information is out of range...
        */

        free(dt);

        return (false);
      }

     /*
      * Convert ISO time to UNIX time in seconds...
      */

      tmdata.tm_year = dt->year - 1900;
      tmdata.tm_mon  = dt->month - 1;
      tmdata.tm_day  = dt->day;
      tmdata.tm_hour = dt->hour;
      tmdata.tm_min  = dt->minute;
      tmdata.tm_sec  = dt->second;

      dt->unix = gmtime(&tmdata);

     /*
      * Assign custom node data and free callback function/data...
      */

      mxmlSetCustom(node, data, custom_free_cb, cbdata);

     /*
      * Return with no errors...
      */

      return (true);
    }

The function itself can return `true` on success or `false` if it is unable to decode the custom data or the data contains an error. Custom data nodes contain a `void` pointer to the allocated custom data for the node and a pointer to a destructor function which will free the custom data when the node is deleted. In this example, we use the standard `free` function since everything is contained in a single calloc'd block.

The save callback receives the node pointer and returns an allocated string containing the custom data value. The following save callback could be used for our ISO date/time type:

    char *
    custom_save_cb(void *cbdata, mxml_node_t *node)
    {
      char data[255];
      iso_date_time_t *dt;

      dt = (iso_date_time_t *)mxmlGetCustom(node);

      snprintf(data, sizeof(data),
               "%04u-%02u-%02uT%02u:%02u:%02uZ",
               dt->year, dt->month, dt->day, dt->hour,
               dt->minute, dt->second);

      return (strdup(data));
    }

You register these callback functions using the mxmlOptionsSetCustomCallbacks function:

    mxmlOptionsSetCustomCallbacks(options, custom_load_cb,
                                  custom_save_cb, /*cbdata*/NULL);

### SAX (Stream) Loading of Documents

Mini-XML supports an implementation of the Simple API for XML (SAX) which allows you to load and process an XML document as a stream of nodes. Aside from allowing you to process XML documents of any size, the Mini-XML implementation also allows you to retain portions of the document in memory for later processing.

The mxmlLoadXxx functions support a SAX option that is enabled by setting a callback function and data pointer with the mxmlOptionsSetSAXCallback function. The callback function receives the data pointer you supplied, the node, and an event code and returns `true` to continue processing or `false` to stop:

    bool
    sax_cb(void *cbdata, mxml_node_t *node,
           mxml_sax_event_t event)
    {
      ... do something ...

      // Continue processing...
      return (true);
    }

The event will be one of the following:

- `MXML_SAX_EVENT_CDATA`: CDATA was just read.

- `MXML_SAX_EVENT_COMMENT`: A comment was just read.

- `MXML_SAX_EVENT_DATA`: Data (integer, opaque, real, or text) was just read.

- `MXML_SAX_EVENT_DECLARATION`: A declaration was just read.

- `MXML_SAX_EVENT_DIRECTIVE`: A processing directive/instruction was just read.

- `MXML_SAX_EVENT_ELEMENT_CLOSE` - A close element was just read (`</element>`)

- `MXML_SAX_EVENT_ELEMENT_OPEN` - An open element was just read (`<element>`)

Elements are released after the close element is processed. All other nodes are released after they are processed. The SAX callback can retain the node using the mxmlRetain function. For example, the following SAX callback will retain all nodes, effectively simulating a normal in-memory load:

    bool
    sax_cb(void *cbdata, mxml_node_t *node, mxml_sax_event_t event)
    {
      if (event != MXML_SAX_ELEMENT_CLOSE)
        mxmlRetain(node);

      return (true);
    }

More typically the SAX callback will only retain a small portion of the document that is needed for post-processing. For example, the following SAX callback will retain the title and headings in an XHTML file. It also retains the (parent) elements like `<html>`, `<head>`, and `<body>`, and processing directives like `<?xml ... ?>` and declarations like `<!DOCTYPE ... >`:

    bool
    sax_cb(void *cbdata, mxml_node_t *node,
           mxml_sax_event_t event)
    {
      if (event == MXML_SAX_ELEMENT_OPEN)
      {
       /*
        * Retain headings and titles...
        */

        const char *element = mxmlGetElement(node);

        if (!strcmp(element, "html") ||
            !strcmp(element, "head") ||
            !strcmp(element, "title") ||
            !strcmp(element, "body") ||
            !strcmp(element, "h1") ||
            !strcmp(element, "h2") ||
            !strcmp(element, "h3") ||
            !strcmp(element, "h4") ||
            !strcmp(element, "h5") ||
            !strcmp(element, "h6"))
          mxmlRetain(node);
      }
      else if (event == MXML_SAX_DECLARATION)
        mxmlRetain(node);
      else if (event == MXML_SAX_DIRECTIVE)
        mxmlRetain(node);
      else if (event == MXML_SAX_DATA)
      {
        if (mxmlGetRefCount(mxmlGetParent(node)) > 1)
        {
         /*
          * If the parent was retained, then retain this data
          * node as well.
          */

          mxmlRetain(node);
        }
      }

      return (true);
    }

The resulting skeleton document tree can then be searched just like one loaded without the SAX callback function. For example, a filter that reads an XHTML document from stdin and then shows the title and headings in the document would look like:

    mxml_options_t *options;
    mxml_node_t *xml, *title, *body, *heading;

    options = mxmlOptionsNew();
    mxmlOptionsSetSAXCallback(options, sax_cb,
                              /*cbdata*/NULL);

    xml = mxmlLoadFd(/*top*/NULL, options, /*fd*/0);

    title = mxmlFindElement(doc, doc, "title", NULL, NULL,
                            MXML_DESCEND_ALL);

    if (title)
      print_children(title);

    body = mxmlFindElement(doc, doc, "body", NULL, NULL,
                           MXML_DESCEND_ALL);

    if (body)
    {
      for (heading = mxmlGetFirstChild(body);
           heading;
           heading = mxmlGetNextSibling(heading))
        print_children(heading);
    }

    mxmlDelete(xml);
    mxmlOptionsDelete(options);

The `print_children` function is:

    void
    print_children(mxml_node_t *parent)
    {
      mxml_node_t *node;
      const char *text;
      bool whitespace;

      for (node = mxmlGetFirstChild(parent);
           node != NULL;
           node = mxmlGetNextSibling(node))
      {
        text = mxmlGetText(node, &whitespace);

        if (whitespace)
          putchar(' ');

        fputs(text, stdout);
      }

      putchar('\n');
    }

### User Data

Each node has an associated user data pointer that can be used to store useful information for your application. The memory used by the data pointer is not managed by Mini-XML so it is up to you to free it as necessary.

The mxmlSetUserData function sets any user (application) data associated with the node while the mxmlGetUserData function gets any user (application) data associated with the node:

    void *
    mxmlGetUserData(mxml_node_t *node);

    void
    mxmlSetUserData(mxml_node_t *node, void *user_data);

### Memory Management

Nodes support reference counting to manage memory usage. The mxmlRetain and mxmlRelease functions increment and decrement a node's reference count, respectively. When the reference count goes to zero, mxmlRelease calls mxmlDelete to actually free the memory used by the node tree. New nodes start with a reference count of `1`. You can get a node's current reference count using the mxmlGetRefCount function.

Strings can also support different kinds of memory management. The default is to use the standard C library strdup and free functions. To use alternate an alternate mechanism, call the mxmlSetStringCallbacks function to set string copy and free callbacks. The copy callback receives the callback data pointer and the string to copy, and returns a new string that will persist for the life of the XML data. The free callback receives the callback data pointer and the copied string and potentially frees the memory used for it. For example, the following code implements a simple string pool that eliminates duplicate strings:

    typedef struct string_pool_s
    {
      size_t num_strings;   // Number of strings
      size_t alloc_strings; // Allocated strings
      char   **strings;      // Array of strings
    } string_pool_t;

    char *
    copy_string(string_pool_t *pool, const char *s)
    {
      size_t i;     // Looping var
      char   *news; // Copy of string

      // See if the string is already in the pool...
      for (i = 0; i < pool->num_strings; i ++)
      {
        if (!strcmp(pool->strings[i], s))
          return (pool->strings[i]);
      }

      // Not in the pool, add new string
      if (pool->num_strings >= pool->alloc_strings)
      {
        // Expand the string pool...
        char **temp; // New strings array

        temp = realloc(pool->strings,
                       (pool->alloc_strings + 32) *
                           sizeof(char *));

        if (temp == NULL)
          return (NULL);

        pool->alloc_strings += 32;
        pool->strings = temp;
      }

      if ((news = strdup(s)) != NULL)
        pool->strings[pool->num_strings ++] = news;

      return (news);
    }

    void
    free_string(string_pool_t *pool, char *s)
    {
      // Do nothing here...
    }

    void
    free_all_strings(string_pool_t *pool)
    {
      size_t i; // Looping var

      for (i = 0; i < pool->num_strings; i ++)
        free(pool->strings[i]);
      free(pool->strings);
    }

    ...

    // Setup the string pool...
    string_pool_t pool = { 0, 0, NULL };

    mxmlSetStringCallbacks((mxml_strcopy_cb_t)copy_string,
                           (mxml_strfree_cb_t)free_string,
                           &pool);

    // Load an XML file...
    mxml_node_t *xml;

    xml = mxmlLoadFilename(/*top*/NULL, /*options*/NULL,
                           "example.xml");

    // Process the XML file...
    ...

    // Free memory used by the XML file...
    mxmlDelete(xml);

    // Free all strings in the pool...
    free_all_strings(&pool);

## Migrating from Mini-XML v3.x

The following incompatible API changes were made in Mini-XML v4.0:

- Load and save callbacks and options are now managed using `mxml_options_t` values.

- The mxmlSAXLoadXxx functions have been removed in favor of setting the SAX callback function and data pointers of the `mxml_options_t` value prior to calling the corresponding mxmlLoadXxx functions.

- SAX events are now named `MXML_SAX_EVENT_foo` instead of `MXML_SAX_foo`.

- SAX callbacks now return a boolean value.

- Node types are now named `MXML_TYPE_foo` instead of `MXML_foo`.

- Descend values are now normalized to `MXML_DESCEND_ALL`, `MXML_DESCEND_FIRST`, and `MXML_DESCEND_NONE`.

- Functions that returned `0` on success and `-1` on error now return `true` on success and `false` on error.

- CDATA nodes ("`<![CDATA[...]]>`") now have their own type (`MXML_TYPE_CDATA`).

- Comment nodes ("`<!-- ... -->`") now have their own type (`MXML_TYPE_COMMENT`).

- Declaration nodes ("`<!...>`") now have their own type (`MXML_TYPE_DECLARATION`).

- Element attributes are now cleared with the mxmlElementClearAttr function instead of mxmlElementDeleteAttr.

- Processing instruction/directive nodes ("`<?...?>`") now have their own type (`MXML_TYPE_DIRECTIVE`).

- Integer nodes (`MXML_TYPE_INTEGER`) now use the `long` type.

- Text nodes (`MXML_TYPE_TEXT`) now use the `bool` type for the whitespace value.

- Custom node callbacks are now set using the mxmlOptionsSetCustomCallbacks function instead of the thread-global mxmlSetCustomHandlers function.

## Functions

### mxmlAdd

Add a node to a tree.

void mxmlAdd(mxml_node_t *parent, mxml_add_t add, mxml_node_t *child, mxml_node_t *node);

#### Parameters

parent | Parent node
add | Where to add, `MXML_ADD_BEFORE` or `MXML_ADD_AFTER`
child | Child node for where or `MXML_ADD_TO_PARENT`
node | Node to add

#### Discussion

This function adds the specified node `node` to the parent. If the `child` argument is not `NULL`, the new node is added before or after the specified child depending on the value of the `add` argument. If the `child` argument is `NULL`, the new node is placed at the beginning of the child list (`MXML_ADD_BEFORE`) or at the end of the child list (`MXML_ADD_AFTER`).

### mxmlDelete

Delete a node and all of its children.

void mxmlDelete(mxml_node_t *node);

#### Parameters

node | Node to delete

#### Discussion

This function deletes the node `node` and all of its children. If the specified node has a parent, this function first removes the node from its parent using the `mxmlRemove` function.

### mxmlElementClearAttr

Remove an attribute from an element.

void mxmlElementClearAttr(mxml_node_t *node, const char *name);

#### Parameters

node | Element
name | Attribute name

#### Discussion

This function removes the attribute `name` from the element `node`.

### mxmlElementGetAttr

Get the value of an attribute.

const char *mxmlElementGetAttr(mxml_node_t *node, const char *name);

#### Parameters

node | Element node
name | Name of attribute

#### Return Value

Attribute value or `NULL`

#### Discussion

This function gets the value for the attribute `name` from the element `node`. `NULL` is returned if the node is not an element or the named attribute does not exist.

### mxmlElementGetAttrByIndex

Get an attribute by index.

const char *mxmlElementGetAttrByIndex(mxml_node_t *node, size_t idx, const char **name);

#### Parameters

node | Node
idx | Attribute index, starting at `0`
name | Attribute name or `NULL` to not return it

#### Return Value

Attribute value

#### Discussion

This function returned the Nth (`idx`) attribute for element `node`. The attribute name is optionallly returned in the `name` argument. `NULL` is returned if node is not an element or the specified index is out of range.

### mxmlElementGetAttrCount

Get the number of element attributes.

size_t mxmlElementGetAttrCount(mxml_node_t *node);

#### Parameters

node | Node

#### Return Value

Number of attributes

#### Discussion

This function returns the number of attributes for the element `node`. `0` is returned if the node is not an element or there are no attributes for the element.

### mxmlElementSetAttr

Set an attribute for an element.

void mxmlElementSetAttr(mxml_node_t *node, const char *name, const char *value);

#### Parameters

node | Element node
name | Name of attribute
value | Attribute value

#### Discussion

This function sets attribute `name` to the string `value` for the element `node`. If the named attribute already exists, the value of the attribute is replaced by the new string value. The string value is copied.

### mxmlElementSetAttrf

Set an attribute with a formatted value.

void mxmlElementSetAttrf(mxml_node_t *node, const char *name, const char *format, ...);

#### Parameters

node | Element node
name | Name of attribute
format | Printf-style attribute value
... | Additional arguments as needed

#### Discussion

This function sets attribute `name` to the formatted value of `format` for the element `node`. If the named attribute already exists, the value of the attribute is replaced by the new formatted string value.

### mxmlFindElement

Find the named element.

mxml_node_t *mxmlFindElement(mxml_node_t *node, mxml_node_t *top, const char *element, const char *attr, const char *value, mxml_descend_t descend);

#### Parameters

node | Current node
top | Top node
element | Element name or `NULL` for any
attr | Attribute name, or `NULL` for none
value | Attribute value, or `NULL` for any
descend | Descend into tree - `MXML_DESCEND_ALL`, `MXML_DESCEND_NONE`, or `MXML_DESCEND_FIRST`

#### Return Value

Element node or `NULL`

#### Discussion

This function finds the named element `element` in XML tree `top` starting at node `node`. The search is constrained by element name `element`, attribute name `attr`, and attribute value `value` - `NULL` names or values are treated as wildcards, so different kinds of searches can be implemented by looking for all elements of a given name or all elements with a specific attribute.
The `descend` argument determines whether the search descends into child nodes; normally you will use `MXML_DESCEND_FIRST` for the initial search and `MXML_DESCEND_NONE` to find additional direct descendents of the node.

### mxmlFindPath

Find a node with the given path.

mxml_node_t *mxmlFindPath(mxml_node_t *top, const char *path);

#### Parameters

top | Top node
path | Path to element

#### Return Value

Found node or `NULL`

#### Discussion

This function finds a node in XML tree `top` using a slash-separated list of element names in `path`. The name "" is considered a wildcard for one or more levels of elements, for example, "foo/one/two", "bar/two/one", "/one", and so forth.
The first child node of the found node is returned if the given node has children and the first child is a value node.

### mxmlGetCDATA

Get the value for a CDATA node.

const char *mxmlGetCDATA(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

CDATA value or `NULL`

#### Discussion

This function gets the string value of a CDATA node. `NULL` is returned if the node is not a CDATA element.

### mxmlGetComment

Get the value for a comment node.

const char *mxmlGetComment(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Comment value or `NULL`

#### Discussion

This function gets the string value of a comment node. `NULL` is returned if the node is not a comment.

### mxmlGetCustom

Get the value for a custom node.

const void *mxmlGetCustom(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Custom value or `NULL`

#### Discussion

This function gets the binary value of a custom node. `NULL` is returned if the node (or its first child) is not a custom value node.

### mxmlGetDeclaration

Get the value for a declaration node.

const char *mxmlGetDeclaration(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Declaraction value or `NULL`

#### Discussion

This function gets the string value of a declaraction node. `NULL` is returned if the node is not a declaration.

### mxmlGetDirective

Get the value for a processing instruction node.

const char *mxmlGetDirective(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Comment value or `NULL`

#### Discussion

This function gets the string value of a processing instruction. `NULL` is returned if the node is not a processing instruction.

### mxmlGetElement

Get the name for an element node.

const char *mxmlGetElement(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Element name or `NULL`

#### Discussion

This function gets the name of an element node. `NULL` is returned if the node is not an element node.

### mxmlGetFirstChild

Get the first child of a node.

mxml_node_t *mxmlGetFirstChild(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

First child or `NULL`

#### Discussion

This function gets the first child of a node. `NULL` is returned if the node has no children.

### mxmlGetInteger

Get the integer value from the specified node or its first child.

long mxmlGetInteger(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Integer value or `0`

#### Discussion

This function gets the value of an integer node. `0` is returned if the node (or its first child) is not an integer value node.

### mxmlGetLastChild

Get the last child of a node.

mxml_node_t *mxmlGetLastChild(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Last child or `NULL`

#### Discussion

This function gets the last child of a node. `NULL` is returned if the node has no children.

### mxmlGetNextSibling

mxml_node_t *mxmlGetNextSibling(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Get the next node for the current parent.

This function gets the next node for the current parent. `NULL` is returned if this is the last child for the current parent.

### mxmlGetOpaque

Get an opaque string value for a node or its first child.

const char *mxmlGetOpaque(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Opaque string or `NULL`

#### Discussion

This function gets the string value of an opaque node. `NULL` is returned if the node (or its first child) is not an opaque value node.

### mxmlGetParent

Get the parent node.

mxml_node_t *mxmlGetParent(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Parent node or `NULL`

#### Discussion

This function gets the parent of a node. `NULL` is returned for a root node.

### mxmlGetPrevSibling

Get the previous node for the current parent.

mxml_node_t *mxmlGetPrevSibling(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Previous node or `NULL`

#### Discussion

This function gets the previous node for the current parent. `NULL` is returned if this is the first child for the current parent.

### mxmlGetReal

Get the real value for a node or its first child.

double mxmlGetReal(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Real value or 0.0

#### Discussion

This function gets the value of a real value node. `0.0` is returned if the node (or its first child) is not a real value node.

### mxmlGetRefCount

Get the current reference (use) count for a node.

size_t mxmlGetRefCount(mxml_node_t *node);

#### Parameters

node | Node

#### Return Value

Reference count

#### Discussion

The initial reference count of new nodes is 1. Use the `mxmlRetain` and `mxmlRelease` functions to increment and decrement a node's reference count.

### mxmlGetText

Get the text value for a node or its first child.

const char *mxmlGetText(mxml_node_t *node, bool *whitespace);

#### Parameters

node | Node to get
whitespace | `true` if string is preceded by whitespace, `false` otherwise

#### Return Value

Text string or `NULL`

#### Discussion

This function gets the string and whitespace values of a text node. `NULL` and `false` are returned if the node (or its first child) is not a text node. The `whitespace` argument can be `NULL` if you don't want to know the whitespace value.
Note: Text nodes consist of whitespace-delimited words. You will only get single words of text when reading an XML file with `MXML_TYPE_TEXT` nodes. If you want the entire string between elements in the XML file, you MUST read the XML file with `MXML_TYPE_OPAQUE` nodes and get the resulting strings using the `mxmlGetOpaque` function instead.

### mxmlGetType

Get the node type.

mxml_type_t mxmlGetType(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

Type of node

#### Discussion

This function gets the type of `node`. `MXML_TYPE_IGNORE` is returned if `node` is `NULL`.

### mxmlGetUserData

Get the user data pointer for a node.

void *mxmlGetUserData(mxml_node_t *node);

#### Parameters

node | Node to get

#### Return Value

User data pointer

#### Discussion

This function gets the user data pointer associated with `node`.

### mxmlIndexDelete

Delete an index.

void mxmlIndexDelete(mxml_index_t *ind);

#### Parameters

ind | Index to delete

### mxmlIndexEnum

Return the next node in the index.

mxml_node_t *mxmlIndexEnum(mxml_index_t *ind);

#### Parameters

ind | Index to enumerate

#### Return Value

Next node or `NULL` if there is none

#### Discussion

This function returns the next node in index `ind`.
You should call `mxmlIndexReset` prior to using this function to get the first node in the index. Nodes are returned in the sorted order of the index.

### mxmlIndexFind

Find the next matching node.

mxml_node_t *mxmlIndexFind(mxml_index_t *ind, const char *element, const char *value);

#### Parameters

ind | Index to search
element | Element name to find, if any
value | Attribute value, if any

#### Return Value

Node or `NULL` if none found

#### Discussion

This function finds the next matching node in index `ind`.
You should call `mxmlIndexReset` prior to using this function for the first time with a particular set of `element` and `value` strings. Passing `NULL` for both `element` and `value` is equivalent to calling `mxmlIndexEnum`.

### mxmlIndexGetCount

Get the number of nodes in an index.

size_t mxmlIndexGetCount(mxml_index_t *ind);

#### Parameters

ind | Index of nodes

#### Return Value

Number of nodes in index

### mxmlIndexNew

Create a new index.

mxml_index_t *mxmlIndexNew(mxml_node_t *node, const char *element, const char *attr);

#### Parameters

node | XML node tree
element | Element to index or `NULL` for all
attr | Attribute to index or `NULL` for none

#### Return Value

New index

#### Discussion

This function creates a new index for XML tree `node`.
The index will contain all nodes that contain the named element and/or attribute. If both `element` and `attr` are `NULL`, then the index will contain a sorted list of the elements in the node tree. Nodes are sorted by element name and optionally by attribute value if the `attr` argument is not `NULL`.

### mxmlIndexReset

Reset the enumeration/find pointer in the index and return the first node in the index.

mxml_node_t *mxmlIndexReset(mxml_index_t *ind);

#### Parameters

ind | Index to reset

#### Return Value

First node or `NULL` if there is none

#### Discussion

This function resets the enumeration/find pointer in index `ind` and should be called prior to using `mxmlIndexEnum` or `mxmlIndexFind` for the first time.

### mxmlLoadFd

Load a file descriptor into an XML node tree.

mxml_node_t *mxmlLoadFd(mxml_node_t *top, mxml_options_t *options, int fd);

#### Parameters

top | Top node
options | Options
fd | File descriptor to read from

#### Return Value

First node or `NULL` if the file could not be read.

#### Discussion

This function loads the file descriptor `fd` into an XML node tree. The nodes in the specified file are added to the specified node `top` - if `NULL` the XML file MUST be well-formed with a single parent processing instruction node like `<?xml version="1.0"?>` at the start of the file.
Load options are provides via the `options` argument. If `NULL`, all values will be loaded into `MXML_TYPE_TEXT` nodes. Use the `mxmlOptionsNew` function to create options when loading XML data.

### mxmlLoadFile

Load a file into an XML node tree.

mxml_node_t *mxmlLoadFile(mxml_node_t *top, mxml_options_t *options, FILE *fp);

#### Parameters

top | Top node
options | Options
fp | File to read from

#### Return Value

First node or `NULL` if the file could not be read.

#### Discussion

This function loads the `FILE` pointer `fp` into an XML node tree. The nodes in the specified file are added to the specified node `top` - if `NULL` the XML file MUST be well-formed with a single parent processing instruction node like `<?xml version="1.0"?>` at the start of the file.
Load options are provides via the `options` argument. If `NULL`, all values will be loaded into `MXML_TYPE_TEXT` nodes. Use the `mxmlOptionsNew` function to create options when loading XML data.

### mxmlLoadFilename

Load a file into an XML node tree.

mxml_node_t *mxmlLoadFilename(mxml_node_t *top, mxml_options_t *options, const char *filename);

#### Parameters

top | Top node
options | Options
filename | File to read from

#### Return Value

First node or `NULL` if the file could not be read.

#### Discussion

This function loads the named file `filename` into an XML node tree. The nodes in the specified file are added to the specified node `top` - if `NULL` the XML file MUST be well-formed with a single parent processing instruction node like `<?xml version="1.0"?>` at the start of the file.
Load options are provides via the `options` argument. If `NULL`, all values will be loaded into `MXML_TYPE_TEXT` nodes. Use the `mxmlOptionsNew` function to create options when loading XML data.

### mxmlLoadIO

Load an XML node tree using a read callback.

mxml_node_t *mxmlLoadIO(mxml_node_t *top, mxml_options_t *options, mxml_io_cb_t io_cb, void *io_cbdata);

#### Parameters

top | Top node
options | Options
io_cb | Read callback function
io_cbdata | Read callback data

#### Return Value

First node or `NULL` if the file could not be read.

#### Discussion

This function loads data into an XML node tree using a read callback. The nodes in the specified file are added to the specified node `top` - if `NULL` the XML file MUST be well-formed with a single parent processing instruction node like `<?xml version="1.0"?>` at the start of the file.
Load options are provides via the `options` argument. If `NULL`, all values will be loaded into `MXML_TYPE_TEXT` nodes. Use the `mxmlOptionsNew` function to create options when loading XML data.
The read callback function `io_cb` is called to read a number of bytes from the source. The callback data pointer `io_cbdata` is passed to the read callback with a pointer to a buffer and the maximum number of bytes to read, for example:
```c size_t my_io_cb(void cbdata, void buffer, size_t bytes) { ... copy up to "bytes" bytes into buffer ... ... return the number of bytes "read" or 0 on error ... } ```

### mxmlLoadString

Load a string into an XML node tree.

mxml_node_t *mxmlLoadString(mxml_node_t *top, mxml_options_t *options, const char *s);

#### Parameters

top | Top node
options | Options
s | String to load

#### Return Value

First node or `NULL` if the string has errors.

#### Discussion

This function loads the string into an XML node tree. The nodes in the specified file are added to the specified node `top` - if `NULL` the XML file MUST be well-formed with a single parent processing instruction node like `<?xml version="1.0"?>` at the start of the file.
Load options are provides via the `options` argument. If `NULL`, all values will be loaded into `MXML_TYPE_TEXT` nodes. Use the `mxmlOptionsNew` function to create options when loading XML data.

### mxmlNewCDATA

Create a new CDATA node.

mxml_node_t *mxmlNewCDATA(mxml_node_t *parent, const char *data);

#### Parameters

parent | Parent node or `NULL`
data | Data string

#### Return Value

New node

#### Discussion

The new CDATA node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new CDATA node has no parent. The data string must be nul-terminated and is copied into the new node.

### mxmlNewCDATAf

Create a new formatted CDATA node.

mxml_node_t *mxmlNewCDATAf(mxml_node_t *parent, const char *format, ...);

#### Parameters

parent | Parent node or `NULL`
format | Printf-style format string
... | Additional args as needed

#### Return Value

New node

#### Discussion

The new CDATA node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new opaque string node has no parent. The format string must be nul-terminated and is formatted into the new node.

### mxmlNewComment

Create a new comment node.

mxml_node_t *mxmlNewComment(mxml_node_t *parent, const char *comment);

#### Parameters

parent | Parent node or `NULL`
comment | Comment string

#### Return Value

New node

#### Discussion

The new comment node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new comment node has no parent. The comment string must be nul-terminated and is copied into the new node.

### mxmlNewCommentf

Create a new formatted comment string node.

mxml_node_t *mxmlNewCommentf(mxml_node_t *parent, const char *format, ...);

#### Parameters

parent | Parent node or `NULL`
format | Printf-style format string
... | Additional args as needed

#### Return Value

New node

#### Discussion

The new comment string node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new opaque string node has no parent. The format string must be nul-terminated and is formatted into the new node.

### mxmlNewCustom

Create a new custom data node.

mxml_node_t *mxmlNewCustom(mxml_node_t *parent, void *data, mxml_custfree_cb_t free_cb, void *free_cbdata);

#### Parameters

parent | Parent node or `NULL`
data | Pointer to data
free_cb | Free callback function or `NULL` if none needed
free_cbdata | Free callback data

#### Return Value

New node

#### Discussion

The new custom node is added to the end of the specified parent's child list. The `free_cb` argument specifies a function to call to free the custom data when the node is deleted.

### mxmlNewDeclaration

Create a new declaraction node.

mxml_node_t *mxmlNewDeclaration(mxml_node_t *parent, const char *declaration);

#### Parameters

parent | Parent node or `NULL`
declaration | Declaration string

#### Return Value

New node

#### Discussion

The new declaration node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new declaration node has no parent. The declaration string must be nul- terminated and is copied into the new node.

### mxmlNewDeclarationf

Create a new formatted declaration node.

mxml_node_t *mxmlNewDeclarationf(mxml_node_t *parent, const char *format, ...);

#### Parameters

parent | Parent node or `NULL`
format | Printf-style format string
... | Additional args as needed

#### Return Value

New node

#### Discussion

The new declaration node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new opaque string node has no parent. The format string must be nul-terminated and is formatted into the new node.

### mxmlNewDirective

Create a new processing instruction node.

mxml_node_t *mxmlNewDirective(mxml_node_t *parent, const char *directive);

#### Parameters

parent | Parent node or `NULL`
directive | Directive string

#### Return Value

New node

#### Discussion

The new processing instruction node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new processing instruction node has no parent. The data string must be nul-terminated and is copied into the new node.

### mxmlNewDirectivef

Create a new formatted processing instruction node.

mxml_node_t *mxmlNewDirectivef(mxml_node_t *parent, const char *format, ...);

#### Parameters

parent | Parent node or `NULL`
format | Printf-style format string
... | Additional args as needed

#### Return Value

New node

#### Discussion

The new processing instruction node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new opaque string node has no parent. The format string must be nul-terminated and is formatted into the new node.

### mxmlNewElement

Create a new element node.

mxml_node_t *mxmlNewElement(mxml_node_t *parent, const char *name);

#### Parameters

parent | Parent node or `NULL`
name | Name of element

#### Return Value

New node

#### Discussion

The new element node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new element node has no parent.

### mxmlNewInteger

Create a new integer node.

mxml_node_t *mxmlNewInteger(mxml_node_t *parent, long integer);

#### Parameters

parent | Parent node or `NULL`
integer | Integer value

#### Return Value

New node

#### Discussion

The new integer node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new integer node has no parent.

### mxmlNewOpaque

Create a new opaque string.

mxml_node_t *mxmlNewOpaque(mxml_node_t *parent, const char *opaque);

#### Parameters

parent | Parent node or `NULL`
opaque | Opaque string

#### Return Value

New node

#### Discussion

The new opaque string node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new opaque string node has no parent. The opaque string must be nul-terminated and is copied into the new node.

### mxmlNewOpaquef

Create a new formatted opaque string node.

mxml_node_t *mxmlNewOpaquef(mxml_node_t *parent, const char *format, ...);

#### Parameters

parent | Parent node or `NULL`
format | Printf-style format string
... | Additional args as needed

#### Return Value

New node

#### Discussion

The new opaque string node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new opaque string node has no parent. The format string must be nul-terminated and is formatted into the new node.

### mxmlNewReal

Create a new real number node.

mxml_node_t *mxmlNewReal(mxml_node_t *parent, double real);

#### Parameters

parent | Parent node or `NULL`
real | Real number value

#### Return Value

New node

#### Discussion

The new real number node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new real number node has no parent.

### mxmlNewText

Create a new text fragment node.

mxml_node_t *mxmlNewText(mxml_node_t *parent, bool whitespace, const char *string);

#### Parameters

parent | Parent node or `NULL`
whitespace | `true` = leading whitespace, `false` = no whitespace
string | String

#### Return Value

New node

#### Discussion

The new text node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new text node has no parent. The whitespace parameter is used to specify whether leading whitespace is present before the node. The text string must be nul-terminated and is copied into the new node.

### mxmlNewTextf

Create a new formatted text fragment node.

mxml_node_t *mxmlNewTextf(mxml_node_t *parent, bool whitespace, const char *format, ...);

#### Parameters

parent | Parent node or `NULL`
whitespace | `true` = leading whitespace, `false` = no whitespace
format | Printf-style format string
... | Additional args as needed

#### Return Value

New node

#### Discussion

The new text node is added to the end of the specified parent's child list. The constant `NULL` can be used to specify that the new text node has no parent. The whitespace parameter is used to specify whether leading whitespace is present before the node. The format string must be nul-terminated and is formatted into the new node.

### mxmlNewXML

Create a new XML document tree.

mxml_node_t *mxmlNewXML(const char *version);

#### Parameters

version | Version number to use

#### Return Value

New ?xml node

#### Discussion

The "version" argument specifies the version number to put in the ?xml directive node. If `NULL`, version "1.0" is assumed.

### mxmlOptionsDelete

Free load/save options.

void mxmlOptionsDelete(mxml_options_t *options);

#### Parameters

options | Options

### mxmlOptionsNew

Allocate load/save options.

mxml_options_t *mxmlOptionsNew(void);

#### Return Value

Options

#### Discussion

This function creates a new set of load/save options to use with the `mxmlLoadFd`, `mxmlLoadFile`, `mxmlLoadFilename`, `mxmlLoadIO`, `mxmlLoadString`, `mxmlSaveAllocString`, `mxmlSaveFd`, `mxmlSaveFile`, `mxmlSaveFilename`, `mxmlSaveIO`, and `mxmlSaveString` functions. Options can be reused for multiple calls to these functions and should be freed using the `mxmlOptionsDelete` function.
The default load/save options load values using the constant type `MXML_TYPE_TEXT` and save XML data with a wrap margin of 72 columns. The various `mxmlOptionsSet` functions are used to change the defaults, for example:

    mxml_options_t *options = mxmlOptionsNew();

    /* Load values as opaque strings */
    mxmlOptionsSetTypeValue(options, MXML_TYPE_OPAQUE);

Note: The most common programming error when using the Mini-XML library is to load an XML file using the `MXML_TYPE_TEXT` node type, which returns inline text as a series of whitespace-delimited words, instead of using the `MXML_TYPE_OPAQUE` node type which returns the inline text as a single string (including whitespace).

### mxmlOptionsSetCustomCallbacks

Set the custom data callbacks.

void mxmlOptionsSetCustomCallbacks(mxml_options_t *options, mxml_custload_cb_t load_cb, mxml_custsave_cb_t save_cb, void *cbdata);

#### Parameters

options | Options
load_cb | Custom load callback function
save_cb | Custom save callback function
cbdata | Custom callback data

#### Discussion

This function sets the callbacks that are used for loading and saving custom data types. The load callback `load_cb` accepts the callback data pointer `cbdata`, a node pointer, and a data string and returns `true` on success and `false` on error, for example:
```c typedef struct { unsigned year, / Year / month, / Month / day, / Day / hour, / Hour / minute, / Minute / second; / Second / time_t unix; / UNIX time / } iso_date_time_t;
void my_custom_free_cb(void cbdata, void data) { free(data); }
bool my_custom_load_cb(void cbdata, mxml_node_t node, const char data) { iso_date_time_t dt; struct tm tmdata;
/ Allocate custom data structure ... / dt = calloc(1, sizeof(iso_date_time_t));
/ Parse the data string... / if (sscanf(data, "%u-%u-%uT%u:%u:%uZ", &(dt->year), &(dt->month), &(dt->day), &(dt->hour), &(dt->minute), &(dt->second)) != 6) { / Unable to parse date and time numbers... / free(dt); return (false); }
/ Range check values... / if (dt->month 1 || dt-month > 12 || dt->day 1 || dt-day > 31 || dt->hour 0 || dt-hour > 23 || dt->minute 0 || dt-minute > 59 || dt->second 0 || dt-second > 60) { / Date information is out of range... / free(dt); return (false); }
/ Convert ISO time to UNIX time in seconds... / tmdata.tm_year = dt->year - 1900; tmdata.tm_mon = dt->month - 1; tmdata.tm_day = dt->day; tmdata.tm_hour = dt->hour; tmdata.tm_min = dt->minute; tmdata.tm_sec = dt->second;
dt->unix = gmtime(&tmdata);
/ Set custom data and free function... / mxmlSetCustom(node, data, my_custom_free, /cbdata/NULL);
/ Return with no errors... / return (true); }

    The save callback `save_cb` accepts the callback data pointer `cbdata` and a
    node pointer and returns a malloc'd string on success and `NULL` on error,
    for example:

    ```c
    char *
    my_custom_save_cb(void *cbdata, mxml_node_t *node)
    {
      char data[255];
      iso_date_time_t *dt;

      /* Get the custom data structure */
      dt = (iso_date_time_t *)mxmlGetCustom(node);

      /* Generate string version of the date/time... */
      snprintf(data, sizeof(data), "%04u-%02u-%02uT%02u:%02u:%02uZ",
               dt->year, dt->month, dt->day, dt->hour, dt->minute, dt->second);

      /* Duplicate the string and return... */
      return (strdup(data));
    }

### mxmlOptionsSetEntityCallback

Set the entity lookup callback to use when loading XML data.

void mxmlOptionsSetEntityCallback(mxml_options_t *options, mxml_entity_cb_t cb, void *cbdata);

#### Parameters

options | Options
cb | Entity callback function
cbdata | Entity callback data

#### Discussion

This function sets the callback that is used to lookup named XML character entities when loading XML data. The callback function `cb` accepts the callback data pointer `cbdata` and the entity name. The function returns a Unicode character value or `-1` if the entity is not known. For example, the following entity callback supports the "euro" entity:
```c int my_entity_cb(void cbdata, const char name) { if (!strcmp(name, "euro")) return (0x20ac); else return (-1); }

    Mini-XML automatically supports the "amp", "gt", "lt", and "quot" character
    entities which are required by the base XML specification.

char *data) { iso_date_time_t

### mxmlOptionsSetErrorCallback

Set the error message callback.

void mxmlOptionsSetErrorCallback(mxml_options_t *options, mxml_error_cb_t cb, void *cbdata);

#### Parameters

options | Options
cb | Error callback function
cbdata | Error callback data

#### Discussion

This function sets a function to use when reporting errors. The callback `cb` accepts the data pointer `cbdata` and a string pointer containing the error message:
```c void my_error_cb(void cbdata, const char message) { fprintf(stderr, "myprogram: %sn", message); }

    The default error callback writes the error message to the `stderr` file.

ack supports the "euro" entity:
```

### mxmlOptionsSetSAXCallback

Set the SAX callback to use when reading XML data.

void mxmlOptionsSetSAXCallback(mxml_options_t *options, mxml_sax_cb_t cb, void *cbdata);

#### Parameters

options | Options
cb | SAX callback function
cbdata | SAX callback data

#### Discussion

This function sets a SAX callback to use when reading XML data. The SAX callback function `cb` and associated callback data `cbdata` are used to enable the Simple API for XML streaming mode. The callback is called as the XML node tree is parsed and receives the `cbdata` pointer, the `mxml_node_t` pointer, and an event code. The function returns `true` to continue processing or `false` to stop:
```c bool sax_cb(void cbdata, mxml_node_t node, mxml_sax_event_t event) { ... do something ...
/ Continue processing... / return (true); }

    The event will be one of the following:

    - `MXML_SAX_EVENT_CDATA`: CDATA was just read.
    - `MXML_SAX_EVENT_COMMENT`: A comment was just read.
    - `MXML_SAX_EVENT_DATA`: Data (integer, opaque, real, or text) was just read.
    - `MXML_SAX_EVENT_DECLARATION`: A declaration was just read.
    - `MXML_SAX_EVENT_DIRECTIVE`: A processing directive/instruction was just read.
    - `MXML_SAX_EVENT_ELEMENT_CLOSE` - A close element was just read (`</element>`)
    - `MXML_SAX_EVENT_ELEMENT_OPEN` - An open element was just read (`<element>`)

    Elements are *released* after the close element is processed.  All other nodes
    are released after they are processed.  The SAX callback can *retain* the node
    using the [mxmlRetain](@@) function.

/* Date information is out of range...

### mxmlOptionsSetTypeCallback

Set the type callback for child/value nodes.

void mxmlOptionsSetTypeCallback(mxml_options_t *options, mxml_type_cb_t cb, void *cbdata);

#### Parameters

options | Options
cb | Type callback function
cbdata | Type callback data

#### Discussion

The load callback function `cb` is called to obtain the node type child/value nodes and receives the `cbdata` pointer and the `mxml_node_t` pointer, for example:
```c mxml_type_t my_type_cb(void cbdata, mxml_node_t node) { const char type; / You can lookup attributes and/or use the element name, hierarchy, etc... */
type = mxmlElementGetAttr(node, "type"); if (type == NULL) type = mxmlGetElement(node); if (type == NULL) type = "text";
if (!strcmp(type, "integer")) return (MXML_TYPE_INTEGER); else if (!strcmp(type, "opaque")) return (MXML_TYPE_OPAQUE); else if (!strcmp(type, "real")) return (MXML_TYPE_REAL); else return (MXML_TYPE_TEXT); } ```

### mxmlOptionsSetTypeValue

Set the type to use for all child/value nodes.

void mxmlOptionsSetTypeValue(mxml_options_t *options, mxml_type_t type);

#### Parameters

options | Options
type | Value node type

#### Discussion

This functions sets a constant node type to use for all child/value nodes.

### mxmlOptionsSetWhitespaceCallback

Set the whitespace callback.

void mxmlOptionsSetWhitespaceCallback(mxml_options_t *options, mxml_ws_cb_t cb, void *cbdata);

#### Parameters

options | Options
cb | Whitespace callback function
cbdata | Whitespace callback data

#### Discussion

This function sets the whitespace callback that is used when saving XML data. The callback function `cb` specifies a function that returns a whitespace string or `NULL` before and after each element. The function receives the callback data pointer `cbdata`, the `mxml_node_t` pointer, and a "when" value indicating where the whitespace is being added, for example:
```c const char my_whitespace_cb(void cbdata, mxml_node_t *node, mxml_ws_t when) { if (when == MXML_WS_BEFORE_OPEN || when == MXML_WS_AFTER_CLOSE) return ("n"); else return (NULL); } ```

### mxmlOptionsSetWrapMargin

Set the wrap margin when saving XML data.

void mxmlOptionsSetWrapMargin(mxml_options_t *options, int column);

#### Parameters

options | Options
column | Wrap column

#### Discussion

This function sets the wrap margin used when saving XML data. Wrapping is disabled when `column` is `0`.

### mxmlRelease

Release a node.

int mxmlRelease(mxml_node_t *node);

#### Parameters

node | Node

#### Return Value

New reference count

#### Discussion

When the reference count reaches zero, the node (and any children) is deleted via `mxmlDelete`.

### mxmlRemove

Remove a node from its parent.

void mxmlRemove(mxml_node_t *node);

#### Parameters

node | Node to remove

#### Discussion

This function does not free memory used by the node - use `mxmlDelete` for that. This function does nothing if the node has no parent.

### mxmlRetain

Retain a node.

int mxmlRetain(mxml_node_t *node);

#### Parameters

node | Node

#### Return Value

New reference count

### mxmlSaveAllocString

Save an XML tree to an allocated string.

char *mxmlSaveAllocString(mxml_node_t *node, mxml_options_t *options);

#### Parameters

node | Node to write
options | Options

#### Return Value

Allocated string or `NULL`

#### Discussion

This function saves the XML tree `node` to an allocated string. The string should be freed using `free` (or the string free callback set using `mxmlSetStringCallbacks`) when you are done with it.
`NULL` is returned if the node would produce an empty string or if the string cannot be allocated.
Save options are provides via the `options` argument. If `NULL`, the XML output will be wrapped at column 72 with no additional whitespace. Use the `mxmlOptionsNew` function to create options for saving XML data.

### mxmlSaveFd

Save an XML tree to a file descriptor.

bool mxmlSaveFd(mxml_node_t *node, mxml_options_t *options, int fd);

#### Parameters

node | Node to write
options | Options
fd | File descriptor to write to

#### Return Value

`true` on success, `false` on error.

#### Discussion

This function saves the XML tree `node` to a file descriptor.
Save options are provides via the `options` argument. If `NULL`, the XML output will be wrapped at column 72 with no additional whitespace. Use the `mxmlOptionsNew` function to create options for saving XML data.

### mxmlSaveFile

Save an XML tree to a file.

bool mxmlSaveFile(mxml_node_t *node, mxml_options_t *options, FILE *fp);

#### Parameters

node | Node to write
options | Options
fp | File to write to

#### Return Value

`true` on success, `false` on error.

#### Discussion

This function saves the XML tree `node` to a stdio `FILE`.
Save options are provides via the `options` argument. If `NULL`, the XML output will be wrapped at column 72 with no additional whitespace. Use the `mxmlOptionsNew` function to create options for saving XML data.

### mxmlSaveFilename

Save an XML tree to a file.

bool mxmlSaveFilename(mxml_node_t *node, mxml_options_t *options, const char *filename);

#### Parameters

node | Node to write
options | Options
filename | File to write to

#### Return Value

`true` on success, `false` on error.

#### Discussion

This function saves the XML tree `node` to a named file.
Save options are provides via the `options` argument. If `NULL`, the XML output will be wrapped at column 72 with no additional whitespace. Use the `mxmlOptionsNew` function to create options for saving XML data.

### mxmlSaveIO

Save an XML tree using a callback.

bool mxmlSaveIO(mxml_node_t *node, mxml_options_t *options, mxml_io_cb_t io_cb, void *io_cbdata);

#### Parameters

node | Node to write
options | Options
io_cb | Write callback function
io_cbdata | Write callback data

#### Return Value

`true` on success, `false` on error.

#### Discussion

This function saves the XML tree `node` using a write callback function `io_cb`. The write callback is called with the callback data pointer `io_cbdata`, a buffer pointer, and the number of bytes to write, for example:
```c size_t my_io_cb(void cbdata, const void buffer, size_t bytes) { ... write/copy bytes from buffer to the output ... ... return the number of bytes written/copied or 0 on error ... }

    Save options are provides via the `options` argument.  If `NULL`, the XML
    output will be wrapped at column 72 with no additional whitespace.  Use the
    @link mxmlOptionsNew@ function to create options for saving XML data.

, "real")) return (MXML_TYPE_REAL); else return (MXML_TYPE_TEXT); } ```

### mxmlSaveString

Save an XML node tree to a string.

size_t mxmlSaveString(mxml_node_t *node, mxml_options_t *options, char *buffer, size_t bufsize);

#### Parameters

node | Node to write
options | Options
buffer | String buffer
bufsize | Size of string buffer

#### Return Value

Size of string

#### Discussion

This function saves the XML tree `node` to a fixed-size string buffer.
Save options are provides via the `options` argument. If `NULL`, the XML output will be wrapped at column 72 with no additional whitespace. Use the `mxmlOptionsNew` function to create options for saving XML data.

### mxmlSetCDATA

Set the data for a CDATA node.

bool mxmlSetCDATA(mxml_node_t *node, const char *data);

#### Parameters

node | Node to set
data | New data string

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the value string for a CDATA node. The node is not changed if it (or its first child) is not a CDATA node.

### mxmlSetCDATAf

Set the data for a CDATA to a formatted string.

bool mxmlSetCDATAf(mxml_node_t *node, const char *format, ...);

#### Parameters

node | Node
format | `printf`-style format string
... | Additional arguments as needed

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the formatted string value of a CDATA node. The node is not changed if it (or its first child) is not a CDATA node.

### mxmlSetComment

Set a comment to a literal string.

bool mxmlSetComment(mxml_node_t *node, const char *comment);

#### Parameters

node | Node
comment | Literal string

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the string value of a comment node.

### mxmlSetCommentf

Set a comment to a formatted string.

bool mxmlSetCommentf(mxml_node_t *node, const char *format, ...);

#### Parameters

node | Node
format | `printf`-style format string
... | Additional arguments as needed

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the formatted string value of a comment node.

### mxmlSetCustom

Set the data and destructor of a custom data node.

bool mxmlSetCustom(mxml_node_t *node, void *data, mxml_custfree_cb_t free_cb, void *free_cbdata);

#### Parameters

node | Node to set
data | New data pointer
free_cb | Free callback function
free_cbdata | Free callback data

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the data pointer `data` and destructor callback `destroy_cb` of a custom data node. The node is not changed if it (or its first child) is not a custom node.

### mxmlSetDeclaration

Set a declaration to a literal string.

bool mxmlSetDeclaration(mxml_node_t *node, const char *declaration);

#### Parameters

node | Node
declaration | Literal string

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the string value of a declaration node.

### mxmlSetDeclarationf

Set a declaration to a formatted string.

bool mxmlSetDeclarationf(mxml_node_t *node, const char *format, ...);

#### Parameters

node | Node
format | `printf`-style format string
... | Additional arguments as needed

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the formatted string value of a declaration node.

### mxmlSetDirective

Set a processing instruction to a literal string.

bool mxmlSetDirective(mxml_node_t *node, const char *directive);

#### Parameters

node | Node
directive | Literal string

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the string value of a processing instruction node.

### mxmlSetDirectivef

Set a processing instruction to a formatted string.

bool mxmlSetDirectivef(mxml_node_t *node, const char *format, ...);

#### Parameters

node | Node
format | `printf`-style format string
... | Additional arguments as needed

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the formatted string value of a processing instruction node.

### mxmlSetElement

Set the name of an element node.

bool mxmlSetElement(mxml_node_t *node, const char *name);

#### Parameters

node | Node to set
name | New name string

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the name of an element node. The node is not changed if it is not an element node.

### mxmlSetInteger

Set the value of an integer node.

bool mxmlSetInteger(mxml_node_t *node, long integer);

#### Parameters

node | Node to set
integer | Integer value

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the value of an integer node. The node is not changed if it (or its first child) is not an integer node.

### mxmlSetOpaque

Set the value of an opaque node.

bool mxmlSetOpaque(mxml_node_t *node, const char *opaque);

#### Parameters

node | Node to set
opaque | Opaque string

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the string value of an opaque node. The node is not changed if it (or its first child) is not an opaque node.

### mxmlSetOpaquef

Set the value of an opaque string node to a formatted string.

bool mxmlSetOpaquef(mxml_node_t *node, const char *format, ...);

#### Parameters

node | Node to set
format | Printf-style format string
... | Additional arguments as needed

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the formatted string value of an opaque node. The node is not changed if it (or its first child) is not an opaque node.

### mxmlSetReal

Set the value of a real value node.

bool mxmlSetReal(mxml_node_t *node, double real);

#### Parameters

node | Node to set
real | Real number value

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the value of a real value node. The node is not changed if it (or its first child) is not a real value node.

### mxmlSetText

Set the value of a text node.

bool mxmlSetText(mxml_node_t *node, bool whitespace, const char *string);

#### Parameters

node | Node to set
whitespace | `true` = leading whitespace, `false` = no whitespace
string | String

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the string and whitespace values of a text node. The node is not changed if it (or its first child) is not a text node.

### mxmlSetTextf

Set the value of a text node to a formatted string.

bool mxmlSetTextf(mxml_node_t *node, bool whitespace, const char *format, ...);

#### Parameters

node | Node to set
whitespace | `true` = leading whitespace, `false` = no whitespace
format | Printf-style format string
... | Additional arguments as needed

#### Return Value

`true` on success, `false` on failure

#### Discussion

This function sets the formatted string and whitespace values of a text node. The node is not changed if it (or its first child) is not a text node.

### mxmlSetUserData

Set the user data pointer for a node.

bool mxmlSetUserData(mxml_node_t *node, void *data);

#### Parameters

node | Node to set
data | User data pointer

#### Return Value

`true` on success, `false` on failure

### mxmlWalkNext

Walk to the next logical node in the tree.

mxml_node_t *mxmlWalkNext(mxml_node_t *node, mxml_node_t *top, mxml_descend_t descend);

#### Parameters

node | Current node
top | Top node
descend | Descend into tree - `MXML_DESCEND_ALL`, `MXML_DESCEND_NONE`, or `MXML_DESCEND_FIRST`

#### Return Value

Next node or `NULL`

#### Discussion

This function walks to the next logical node in the tree. The `descend` argument controls whether the first child is considered to be the next node. The `top` argument constrains the walk to that node's children.

### mxmlWalkPrev

Walk to the previous logical node in the tree.

mxml_node_t *mxmlWalkPrev(mxml_node_t *node, mxml_node_t *top, mxml_descend_t descend);

#### Parameters

node | Current node
top | Top node
descend | Descend into tree - `MXML_DESCEND_ALL`, `MXML_DESCEND_NONE`, or `MXML_DESCEND_FIRST`

#### Return Value

Previous node or `NULL`

#### Discussion

This function walks to the previous logical node in the tree. The `descend` argument controls whether the first child is considered to be the next node. The `top` argument constrains the walk to that node's children.

## Data Types

### mxml_add_t

`mxmlAdd` add values

typedef enum mxml_add_e mxml_add_t;

### mxml_custfree_cb_t

Custom data destructor

typedef void (*mxml_custfree_cb_t)(void *cbdata void *custdata);

### mxml_custload_cb_t

Custom data load callback function

typedef bool (*mxml_custload_cb_t)(void *cbdata mxml_node_t *node const char *s);

### mxml_custsave_cb_t

Custom data save callback function

typedef char *(*mxml_custsave_cb_t)(void *cbdata mxml_node_t *node);

### mxml_descend_t

`mxmlFindElement`, `mxmlWalkNext`, and `mxmlWalkPrev` descend values

typedef enum mxml_descend_e mxml_descend_t;

### mxml_entity_cb_t

Entity callback function

typedef int (*mxml_entity_cb_t)(void *cbdata const char *name);

### mxml_error_cb_t

Error callback function

typedef void (*mxml_error_cb_t)(void *cbdata const char *message);

### mxml_index_t

An XML node index

typedef struct _mxml_index_s mxml_index_t;

### mxml_io_cb_t

Read/write callback function

typedef size_t (*mxml_io_cb_t)(void *cbdata void *buffer size_t bytes);

### mxml_node_t

An XML node

typedef struct _mxml_node_s mxml_node_t;

### mxml_options_t

XML options

typedef struct _mxml_options_s mxml_options_t;

### mxml_sax_cb_t

SAX callback function

typedef bool (*mxml_sax_cb_t)(void *cbdata mxml_node_t *node mxml_sax_event_t event);

### mxml_sax_event_t

SAX event type.

typedef enum mxml_sax_event_e mxml_sax_event_t;

### mxml_strcopy_cb_t

String copy/allocation callback

typedef char *(*mxml_strcopy_cb_t)(void *cbdata const char *s);

### mxml_strfree_cb_t

String free callback

typedef void (*mxml_strfree_cb_t)(void *cbdata char *s);

### mxml_type_cb_t

Type callback function

typedef mxml_type_t (*mxml_type_cb_t)(void *cbdata mxml_node_t *node);

### mxml_type_t

The XML node type.

typedef enum mxml_type_e mxml_type_t;

### mxml_ws_cb_t

Whitespace callback function

typedef const char *(*mxml_ws_cb_t)(void *cbdata mxml_node_t *node mxml_ws_t when);

### mxml_ws_t

Whitespace periods

typedef enum mxml_ws_e mxml_ws_t;

## Constants

### mxml_add_e

`mxmlAdd` add values

#### Constants

MXML_ADD_AFTER | Add node after specified node
MXML_ADD_BEFORE | Add node before specified node

### mxml_descend_e

`mxmlFindElement`, `mxmlWalkNext`, and `mxmlWalkPrev` descend values

#### Constants

MXML_DESCEND_ALL | Descend when finding/walking
MXML_DESCEND_FIRST | Descend for first find
MXML_DESCEND_NONE | Don't descend when finding/walking

### mxml_sax_event_e

SAX event type.

#### Constants

MXML_SAX_EVENT_CDATA | CDATA node
MXML_SAX_EVENT_COMMENT | Comment node
MXML_SAX_EVENT_DATA | Data node
MXML_SAX_EVENT_DECLARATION | Declaration node
MXML_SAX_EVENT_DIRECTIVE | Processing instruction node
MXML_SAX_EVENT_ELEMENT_CLOSE | Element closed
MXML_SAX_EVENT_ELEMENT_OPEN | Element opened

### mxml_type_e

The XML node type.

#### Constants

MXML_TYPE_CDATA | CDATA value ("[CDATA[...]]")
MXML_TYPE_COMMENT | Comment ("!--...--")
MXML_TYPE_CUSTOM | Custom data
MXML_TYPE_DECLARATION | Declaration ("!...")
MXML_TYPE_DIRECTIVE | Processing instruction ("?...?")
MXML_TYPE_ELEMENT | XML element with attributes
MXML_TYPE_IGNORE | Ignore/throw away node
MXML_TYPE_INTEGER | Integer value
MXML_TYPE_OPAQUE | Opaque string
MXML_TYPE_REAL | Real value
MXML_TYPE_TEXT | Text fragment

### mxml_ws_e

Whitespace periods

#### Constants

MXML_WS_AFTER_CLOSE | Callback for after close tag
MXML_WS_AFTER_OPEN | Callback for after open tag
MXML_WS_BEFORE_CLOSE | Callback for before close tag
MXML_WS_BEFORE_OPEN | Callback for before open tag